/*===========================================================================
						     1-WIRE.
===========================================================================*/
unsigned char data, command;
unsigned char presence_ds18b20_1 = 0;	//   .
unsigned char presence_ds18b20_2 = 0;	//   .
unsigned char presence_ds18b20_3 = 0;	//   .
//---------------------------------------------------------------------------
void Conv_Cels();
void DS18B20_1();
void DS18B20_2();
void DS18B20_3();
void reset_ds18b20_1(void);
void send_ds18b20_command_1(unsigned char command);
void receive_ds18b20_1(void);
void reset_ds18b20_2(void);
void send_ds18b20_command_2(unsigned char command);
void receive_ds18b20_2(void);
void reset_ds18b20_3(void);
void send_ds18b20_command_3(unsigned char command);
void receive_ds18b20_3(void);
/*===========================================================================
							  .
===========================================================================*/
void DS18B20_1()
{
	reset_ds18b20_1();				// C DS18B20.
	send_ds18b20_command_1(0xCC);	//  Skip ROM.
	send_ds18b20_command_1(0x44);	//    t.
	delay_ms(1);					//   1 .
	reset_ds18b20_1();				// C DS18B20.
	send_ds18b20_command_1(0xCC);	//  Skip ROM.
	send_ds18b20_command_1(0xBE);	//    .
	receive_ds18b20_1();			//   .
	return ;
}
//---------------------------------------------------------------------------
void DS18B20_2()
{
	reset_ds18b20_2();				// C DS18B20.
	send_ds18b20_command_2(0xCC);	//  Skip ROM.
	send_ds18b20_command_2(0x44);	//    t.
	delay_ms(1);					//   1 .
	reset_ds18b20_2();				// C DS18B20.
	send_ds18b20_command_2(0xCC);	//  Skip ROM.
	send_ds18b20_command_2(0xBE);	//    .
	receive_ds18b20_2();			//   .
	return ;
}
//---------------------------------------------------------------------------
void DS18B20_3()
{
	reset_ds18b20_3();					// C DS18B20.
	if (presence_ds18b20_3 == 1)		//    
	{									// .  ,  . .
		send_ds18b20_command_3(0xCC);	//  Skip ROM.
		send_ds18b20_command_3(0x44);	//    t.
		delay_ms(1);					//   1 .
		reset_ds18b20_3();				// C DS18B20.
		send_ds18b20_command_3(0xCC);	//  Skip ROM.
		send_ds18b20_command_3(0xBE);	//   . .
		receive_ds18b20_3();			//   .
	}
	return ;
}
/*=========================================================================*/

/*---------------------------------------------------------------------------
							  DS18B20.
---------------------------------------------------------------------------*/
void reset_ds18b20_1(void)
{
	output_low(DS_1);			//    DS18B20  0.
	delay_us(480);				//     .  480 .
	output_float(DS_1);			//     .
	delay_us(70);				//    70 .
	if (input(DS_1) == 1)		//  =1 -   .
	{
		presence_ds18b20_1 = 0;
	}
	else
	{
		presence_ds18b20_1 = 1;	//  =0 -   .
	}
	delay_us(410);				//  410
	return;
}
/*---------------------------------------------------------------------------
							  .
---------------------------------------------------------------------------*/
void send_ds18b20_command_1(unsigned char command)
{
	data = command;
	for (i = 0; i < 8; i++)
	{
		data = data<<7;				//   7  .
		command = command>>1;		//   .
		if (data == 0x80)			//  .1
		{
			output_low(DS_1);
			delay_us(10);			//  6 .
			output_high(DS_1);		//     .
			delay_us(60);			//  64 .
		}
		else						//  .0.
		{
			output_low(DS_1);
			delay_us(60);			//  60 .
			output_high(DS_1);		//     .
			delay_us(10);			//  10 .
		}
		data = command;				//    .
	}
	return;
}
/*---------------------------------------------------------------------------
				      DS18B20.
---------------------------------------------------------------------------*/
void receive_ds18b20_1(void)
{
	Celsio[1] = 0;
	for (i = 0; i < 16; i++)		//  2     .
	{
		output_low(DS_1);
		delay_us(1);					//  10 .
		output_float(DS_1);				//     .
		delay_us(10);					//  15 .
		if (input(DS_1) == 1)			//   .
		{
			bit_set(Celsio[1], 15);		//  . 1
			if (i < 15)
			{
				Celsio[1] >>= 1;
			}
		}
		else
		{
			bit_clear(Celsio[1], 15);	//  . 0
			if (i < 15)
			{
				Celsio[1] >>= 1;
			}
		}
		delay_us(55);
	}
	Celsio_1[2] = Celsio[1] & 0x000F;	//    .
	Celsio_1[1] = Celsio[1] >> 4;		//    4 a .
	return;
}
/*---------------------------------------------------------------------------
							  DS18B20.
---------------------------------------------------------------------------*/
void reset_ds18b20_2(void)
{
	output_low(DS_2);			//    DS18B20  0.
	delay_us(480);				//     .  480 .
	output_float(DS_2);			//     .
	delay_us(70);				//    70 .
	if (input(DS_2) == 1)		//  =1 -   .
	{
		presence_ds18b20_2 = 0;
	}
	else
	{
		presence_ds18b20_2 = 1;	//  = 0 -   .
	}
	delay_us(410);				//  410
	return;
}
/*---------------------------------------------------------------------------
							  .
---------------------------------------------------------------------------*/
void send_ds18b20_command_2(unsigned char command)
{
	data = command;
	for (i = 0; i < 8; i++)
	{
		data = data << 7;			//   7  .
		command = command >> 1;		//   .
		if (data == 0x80)			//  .1
		{
			output_low(DS_2);
			delay_us(10);			//  6 .
			output_high(DS_2);		//     .
			delay_us(60);			//  64 .
		}
		else						//  .0.
		{
			output_low(DS_2);
			delay_us(60);			//  60 .
			output_high(DS_2);		//     .
			delay_us(10);			//  10 .
		}
		data = command;				//    .
	}
	return;
}
/*---------------------------------------------------------------------------
				      DS18B20.
---------------------------------------------------------------------------*/
void receive_ds18b20_2(void)
{
	Celsio[2] = 0;
	for (i = 0; i < 16; i++)		//  2     .
	{
		output_low(DS_2);
		delay_us(1);					//  10 .
		output_float(DS_2);				//     .
		delay_us(15);					//  15 .
		if (input(DS_2) == 1)			//   .
		{
			bit_set(Celsio[2], 15);		//  . 1
			if (i < 15)
			{
				Celsio[2] >>= 1;
			}
		}
		else
		{
			bit_clear(Celsio[2], 15);	//  . 0
			if (i < 15)
			{
				Celsio[2] >>= 1;
			}
		}      
		delay_us(55);
	}
	Celsio_2[2] = Celsio[2] & 0x000F;	//    .
	Celsio_2[1] = Celsio[2] >> 4;		//    4 a .
	return;
}
/*---------------------------------------------------------------------------
							  DS18B20.
---------------------------------------------------------------------------*/
void reset_ds18b20_3(void)
{
	output_low(DS_3);			//    DS18B20  0.
	delay_us(480);				//     .  480 .
	output_float(DS_3);			//     .
	delay_us(70);				//    70 .
	if (input(DS_3) == 1)		//  =1 -   .
	{
		presence_ds18b20_3 = 0;
	}
	else
	{
		presence_ds18b20_3 = 1;	//  =0 -   .
	}
	delay_us(410);				//  410
	return;
}
/*---------------------------------------------------------------------------
							  .
---------------------------------------------------------------------------*/
void send_ds18b20_command_3(unsigned char command)
{
	data = command;
	for (i = 0; i < 8; i++)
	{
		data = data<<7;				//   7  .
		command = command>>1;		//   .
		if (data == 0x80)			//  .1
		{
			output_low(DS_3);
			delay_us(10);			//  6 .
			output_high(DS_3);		//     .
			delay_us(60);			//  64 .
		}
		else						//  .0.
		{
			output_low(DS_3);
			delay_us(60);			//  60 .
			output_high(DS_3);		//     .
			delay_us(10);			//  10 .
		}
		data = command;				//    .
	}
	return;
}
/*---------------------------------------------------------------------------
				      DS18B20.
---------------------------------------------------------------------------*/
void receive_ds18b20_3(void)
{
	Celsio[3] = 0;
	for (i = 0; i < 16; i++)		//  2     .
	{
		output_low(DS_3);
		delay_us(1);					//  10 .
		output_float(DS_3);				//     .
		delay_us(10);					//  15 .
		if (input(DS_3) == 1)			//   .
		{
			bit_set(Celsio[3], 15);		//  . 1
			if (i < 15)
			{
				Celsio[3] >>= 1;
			}
		}
		else
		{
			bit_clear(Celsio[3], 15);	//  . 0
			if (i < 15)
			{
				Celsio[3] >>= 1;
			}
		}
		delay_us(55);
	}
	Celsio_3[2] = Celsio[3] & 0x000F;	//    .
	Celsio_3[1] = Celsio[3] >> 4;		//    4 a .
	return;
}
/*=========================================================================*/
